/*  BSD-License:

Copyright (c) 2007 by Nils Springob, nicai-systems, Germany

All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

  * Redistributions of source code must retain the above copyright notice,
    this list of conditions and the following disclaimer.
  * Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
  * Neither the name nicai-systems nor the names of its contributors may be
    used to endorse or promote products derived from this software without
    specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/

#include "utility/niboconfig.h"
#ifndef NIBO_USE_BOT
#error NIBO_USE_BOT must be defined in niboconfig.h when this file is compiled
#endif
#ifndef NIBO_USE_ADC
#error NIBO_USE_ADC must be defined in niboconfig.h when this file is compiled
#endif

#include "utility/iodefs.h"
#include "utility/analog.h"
#include "utility/bot.h"
#include <util/delay.h> 


#ifndef SVN_REVISION 
#define SVN_REVISION "arduino"
#endif
#ifndef VERSION
#define VERSION "1"
#endif

#ifdef __cplusplus
extern "C" {
#endif

const char bot_lib_revision[] PROGMEM = SVN_REVISION;
const char bot_lib_version[] PROGMEM = VERSION;

void bot_init(void) {
  // Reset controllers
  activate_output_bit(IO_RESET_CO);
  clear_output_bit(IO_RESET_CO);
  _delay_ms(10);
  set_output_bit(IO_RESET_CO);
  _delay_ms(100);
}


#ifdef __cplusplus
} // extern "C"
#endif
