 


function hasClass(element, className) {
  var items, idx;
  items = (element.className+'').split(' ');
  idx = items.indexOf(className);
  return (idx>=0);
}

function addClass(element, className) {
  var items, idx;
  items = (element.className+'').split(' ');
  idx = items.indexOf(className);
  if (idx<0) {
    items.push(className);
  }
  element.className = items.join(' ');
}

function removeClass(element, className) {
  var items, idx;
  items = (element.className+'').split(' ');
  idx = items.indexOf(className);
  if (idx>=0) {
    items.splice(idx, 1);
  }
  element.className = items.join(' ');
}

function toggleClass(element, className) {
  var items, idx;
  items = (element.className+'').split(' ');
  idx = items.indexOf(className);
  if (idx<0) {
    items.push(className);
  } else {
    items.splice(idx, 1);
  }
  element.className = items.join(' ');
}


function toggleElement(elementId) {
  var el = document.getElementById(elementId);
  if (hasClass(el, 'hidden-section')) {
    removeClass(el, 'hidden-section');
    addClass(el, 'visible-section');
  } else {
    removeClass(el, 'visible-section');
    addClass(el, 'hidden-section');
  }
}

function zebraTable(elementId) {
  var table, trs, i, val;
  table = (typeof elementId == 'string')?document.getElementById(elementId):elementId;
  trs = table.getElementsByTagName('tr');
  val = "even";
  for (i=0; i<trs.length; i++) {
    if (trs[i].className=='') {
      if (trs[i].getElementsByTagName('th').length==0) {
        addClass(trs[i], val);
        val = (val=='even')?'odd':'even';
      } else {
        addClass(trs[i], 'head');
      }
    }
  }
}


function makeToggleSection(elementId, visible) {
  var el, h2;
  el = document.getElementById(elementId);
  h2 = el.getElementsByTagName('h2')[0];
  if (visible) {
    addClass(el, "visible-section");
  } else {
    addClass(el, "hidden-section");
  }
  h2.onclick = function () {toggleElement(elementId);};
}

