/*
Dieses Programm testet die Motoransteuerung. Zus�tzlich wird 
noch die Versorgungsspannung und das zuletzt empfangene
RC5-Kommando angezeigt.
*/

#include <nibo/niboconfig.h>            /* muss immer als erste Datei
                                           eingebunden werden */
#include <nibo/display.h>               /* stellt die grundlegenden Routinen
                                           zur Displayansteuerung zur
                                           Verfügung */
#include <nibo/gfx.h>                   /* stellt die Routinen zur Ansteuerung
                                           eines Grafikdisplays zur Verfügung */
#include <nibo/irco.h>
#include <nibo/delay.h>
#include <nibo/iodefs.h>
#include <nibo/bot.h>
#include <nibo/motco.h>
#include <avr/interrupt.h>
#include <nibo/i2cmaster.h>
#include <stdio.h>


int main() {
  sei(); // enable interrupts
  bot_init();
  i2c_init();
  display_init();                       /* Displayansteuerung initialisieren */
  gfx_init();                           /* Grafikdisplay initialisieren */

  gfx_move(62, 0);
  gfx_set_proportional(1);
  gfx_print_text("motion");
  gfx_set_proportional(0);

  gfx_move(5, 0);
  gfx_print_char('R');

  gfx_move(118, 0);
  gfx_print_char('L');

  delay(50);
  irco_startMeasure();
  motco_setSpeedParameters(5, 6, 7);

  int counter=0;
  irco_update();
  while (1) {
    // IR Controller
    delay(10);

    char text[20]="RC5: ----";
   
    //irco_startMeasure(); 
    //motco_update();
    //if (irco_update())
    //{
    //  sprintf(text, "RC5: %04x", (int)irco_rc5_cmd);
    //}
    gfx_move(35, 45);
    gfx_print_text(text);

    // Spannung
    bot_update();
    float volt = 0.0166 * bot_supply - 1.19;
    sprintf(text, "%2.1fV ", (double)volt);
    gfx_move(25, 0);
    gfx_print_text(text);

    switch(++counter) {
      case 200:
        //motco_update();
        //motco_update();
        motco_setSpeed(20, 20);
        //motco_update();
        break;

      case 400:
        motco_stop();
        //motco_update();
        break;

      case 600:
        motco_setSpeed(-20, -20);
        //motco_update();
        break;

      case 800:
        motco_stop();
        //motco_update();
        counter=0;
        break;
    }
  }
  return 0;                             /* Fertig.... */
}
