#include <nibo/niboconfig.h>
#include <nibo/display.h>
#include <nibo/gfx.h>
#include <nibo/irco.h>
#include <nibo/delay.h>
#include <nibo/iodefs.h>
#include <nibo/adc.h>
#include <nibo/bot.h>
#include <avr/interrupt.h>
#include <nibo/i2cmaster.h>
#include <nibo/floor.h>
#include <nibo/leds.h>
#include <nibo/uart0.h>
#include <stdio.h>

#include <avr/io.h>

#define TRUE 1

uint16_t value_off[4];
uint16_t value_on[4];

void measure_ground()
{
	floor_disable_ir();
	delay(1);
	floor_update();
	value_off[0] = floor_r;
	value_off[1] = line_r;
	value_off[2] = line_l;
	value_off[3] = floor_l;
	floor_enable_ir();
	delay(1);
	floor_update();
	value_on[0] = floor_r;
	value_on[1] = line_r;
	value_on[2] = line_l;
	value_on[3] = floor_l;
	floor_disable_ir();
}

uint8_t diff_ground(int16_t val)
{
	if(val>255)
		val=255;
	if (val<0)
		val=0;
	return val;
}

int main()
{
        char cnt='0';
	sei();
	bot_init();
	i2c_init();
	floor_init();
	display_init();
	leds_init();
        uart0_set_baudrate(9600);
	uart0_enable();
	gfx_init();
	gfx_move(62, 0);
	gfx_set_proportional(1);
	gfx_print_text("UART Test");
	gfx_move(5, 0);
	gfx_print_text("Received: ");
        gfx_set_proportional(0);
	delay(50);
	irco_startMeasure();
	while (TRUE)
	{
        	// RS232 communication
		char c = 'X';
		if (!uart0_rxempty()) {
			c = uart0_getchar();
			gfx_move(40, 10);
			gfx_print_char(c);
                        uart0_putchar(cnt++);
                        if (cnt>'9') cnt='0';
		}
	}
	return 0;
}
