/*  BSD-License:

Copyright (c) 2007 by Nils Springob, nicai-systems, Germany

All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

  * Redistributions of source code must retain the above copyright notice,
    this list of conditions and the following disclaimer.
  * Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
  * Neither the name nicai-systems nor the names of its contributors may be
    used to endorse or promote products derived from this software without
    specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/

#include "iodefs.h"
#include "persistent.h"
#include <avr/eeprom.h>

persistent_t persistent;

uint8_t persistent_dirty;

uint8_t persistent_sysconf[4];


void persistent_update() {
  if (eeprom_read_byte((uint8_t *)0)==0xa5) {
    eeprom_read_block(&persistent, (void *)1, sizeof(persistent_t));
  } else {
    persistent.pid_kp = 5;
    persistent.pid_ki = 6;
    persistent.pid_kd = 7;
  }
  eeprom_read_block(persistent_sysconf, (void *)128, 4);
  if ((persistent_sysconf[0]|persistent_sysconf[1]|persistent_sysconf[2]|persistent_sysconf[3])==0xff) {
    persistent_sysconf[0] = 2;
    persistent_sysconf[1] = 7;
    persistent_sysconf[2] = 0;
    persistent_sysconf[3] = 0;
  }
}

void persistent_commit() {
  eeprom_write_block (&persistent, (void *)1, sizeof(persistent_t));
  eeprom_write_byte((uint8_t *)0, 0xa5);
  persistent_dirty = 0;
}


