
#include <util/atomic.h>


// private:
extern volatile int16_t acquisition_val[8];
extern volatile int16_t acquisition_diff[4];
extern volatile int8_t acquisition_floorstates[4];
extern uint16_t acquisition_calibration[4];

// public:

enum {
  FLOOR_ABYSS,
  FLOOR_STREET,
  FLOOR_LINE
};


void acquisition_setup();

static inline int16_t acquisition_getValue(uint8_t idx) {
  int16_t result;
  ATOMIC_BLOCK(ATOMIC_RESTORESTATE) {
    result = acquisition_val[idx];
  }
  return result;
}

static inline int16_t acquisition_getDiff(uint8_t idx) {
  int16_t result;
  ATOMIC_BLOCK(ATOMIC_RESTORESTATE) {
    result = acquisition_diff[idx];
  }
  return result;
}

static inline int8_t acquisition_getFloorState(uint8_t idx) {
  return acquisition_floorstates[idx];
}


enum {
  STATE_NO_LINE,
  STATE_NO_LINE_L,
  STATE_NO_LINE_R,
  STATE_LINE,
  STATE_LINE_L,
  STATE_LINE_R,
};

extern volatile uint8_t acquisition_linestate;
//extern volatile uint8_t acquisition_floor_bin;
