// NIBO 2 robot definitions


#define NBP_REGISTERS 32

enum {
  /* System */
  NBPREG_BOTID     =  0,
  NBPREG_VERSION   =  1,
  NBPREG_VSUPPLY   =  2,
  /* LEDs */
  NBPREG_LEDSR     =  3,
  NBPREG_LEDSG     =  4,
  NBPREG_LEDSWPWM  =  5,
  /* Motor */
  NBPREG_MOTMODE   =  6,
  NBPREG_MOTPWML   =  7,
  NBPREG_MOTPWMR   =  8,
  NBPREG_MOTPIDL   =  9,
  NBPREG_MOTPIDR   = 10,
  NBPREG_MOTCURL   = 11,
  NBPREG_MOTCURR   = 12,
  /* Odometry */ 
  NBPREG_ODOL      = 13,
  NBPREG_ODOR      = 14,
  /* Floor/Line */
  NBPREG_FLOORL    = 15,
  NBPREG_FLOORR    = 16,
  NBPREG_LINEL     = 17,
  NBPREG_LINER     = 18,
  /* Distance */
  NBPREG_DIST_L    = 19,
  NBPREG_DIST_FL   = 20,
  NBPREG_DIST_F    = 21,
  NBPREG_DIST_FR   = 22,
  NBPREG_DIST_R    = 23
};

#define NBP_REGISTER_TEXT \
  "Registers:\n"\
  "=========\n"\
  " 0: BOT ID\n"\
  " 1: Version\n"\
  " 2: Supply Voltage [mV]\n"\
  " 3: red LEDs\n"\
  " 4: green LEDs\n"\
  " 5: PWM white LEDs\n"\
  " 6: Motor Mode \n"\
  " 7: Motor PWM L \n"\
  " 8: Motor PWM R \n"\
  " 9: Motor PID L \n"\
  "10: Motor PID R \n"\
  "11: Motor current L \n"\
  "12: Motor current R \n"\
  "13: Odometry L \n"\
  "14: Odometry R \n"\
  "15: Floor L\n"\
  "16: Floor R\n"\
  "17: Line L\n"\
  "18: Line R\n"\
  "19: Dist L\n"\
  "20: Dist FL\n"\
  "21: Dist F\n"\
  "22: Dist FR\n"\
  "23: Dist R \n"
  
  
  