#include <nibo/niboconfig.h>
#include <nibo/display.h>
#include <nibo/gfx.h>
#include <nibo/delay.h>
#include <nibo/iodefs.h>
#include <nibo/bot.h>
#include <nibo/floor.h>
#include <nibo/analog.h>
#include <nibo/pwm.h>
#include <stdio.h>
#include <avr/interrupt.h>

void printvals(uint16_t v0, uint16_t v1, char * name) {
    char text[25]="--  --  --  --  --";
    uint16_t d = (v0>v1)?(v0-v1):(v1-v0);
    sprintf(text, "%s: %03x  %03x  %03x\n", name, v0, v1, d);
    gfx_term_print(text);
}



int main() {
  bot_init();
  floor_init();
  display_init();
  gfx_init();
  pwm_init();
  leds_set_displaylight(1024);
  gfx_term_clear();
  
  while (1==1) {
    sei();
    delay(100);
    gfx_term_goto(0, 0);
    char text[20]="--  --  --  --  --";
    printvals(analog_getValue(ANALOG_INPUT20), analog_getValue(ANALOG_INPUT21), "I2");
    printvals(analog_getValue(ANALOG_INPUT30), analog_getValue(ANALOG_INPUT31), "I3");
    printvals(analog_getValue(ANALOG_LINE_L0), analog_getValue(ANALOG_LINE_L1), "LL");
    printvals(analog_getValue(ANALOG_LINE_R0), analog_getValue(ANALOG_LINE_R1), "LR");
    printvals(analog_getValue(ANALOG_FLOOR_L0), analog_getValue(ANALOG_FLOOR_L1), "FL");
    printvals(analog_getValue(ANALOG_FLOOR_R0), analog_getValue(ANALOG_FLOOR_R1), "FR");
    sprintf(text, "VS: %03x", (uint16_t)(analog_getValue(ANALOG_SUPPLY)));
    gfx_term_print(text);    
  }

  return 0;
}
