#include <nibobee/iodefs.h>
#include <nibobee/i2cmaster.h>
#include <nibobee/bgx1.h>
#include <nibobee/analog.h>
#include <nibobee/led.h>
#include <nibobee/delay.h>
#include <nibobee/clock.h>
#include <nibobee/odometry.h>
#include <nibobee/motpwm.h>
#include <nibobee/motpid.h>

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <stdio.h>

int main() {
  activate_output_group(IO_LEDS);  // LED bits als Output
  i2c_init();

  led_set(LED_L_YE, 0);    
  led_set(LED_R_YE, 0);
  led_set(LED_L_RD, 1);    
  led_set(LED_R_RD, 1);
  while (!bgx1_init());
  led_set(LED_L_YE, 1);   
  led_set(LED_R_YE, 1);
  led_set(LED_L_RD, 0);   
  led_set(LED_R_RD, 0);

  motpwm_init();
  motpid_init();
  
  
  while(1) {
    sei();
    if (bgx1_getStatus()==0xff) {
      delay(1500);

      bgx1_reset();

      bgx1_termPrint("Please press a key...");    
      bgx1_Leds=0x01;
      bgx1_syncInterface();
      delay(200);
      bgx1_Leds=0x00;
      bgx1_syncInterface();
      delay(200);
      bgx1_Leds=0x01;
      bgx1_syncInterface();
      delay(200);
      bgx1_Leds=0x00;
      bgx1_syncInterface();
      bgx1_termGoto(0, 2);
    }
      
    delay(1);
    bgx1_syncInterface();
    
    if (bgx1_Keys!=0) {
      switch (bgx1_Keys) {
        case 0x01: bgx1_termPrint("Hello! "); break;
        case 0x02: bgx1_termPrint("I am the autonomous NIBObee robot. "); break;
        case 0x04: bgx1_termPrint("\n"); break;
        case 0x08: bgx1_termClear(); break;
      }
      
      while (bgx1_Keys!=0) {
        bgx1_syncInterface();
        delay(1);
      }
    }
        
  }
  return 0;
}
