#include <nibobee/iodefs.h>
#include <nibobee/i2cmaster.h>
#include <nibobee/bgx1.h>
#include <nibobee/analog.h>
#include <nibobee/led.h>
#include <nibobee/delay.h>
#include <nibobee/clock.h>
#include <nibobee/odometry.h>
#include <nibobee/motpwm.h>
#include <nibobee/motpid.h>

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <stdio.h>

int main() {
  activate_output_group(IO_LEDS);  // LED bits als Output
  i2c_init();

  led_set(LED_L_YE, 0);    
  led_set(LED_R_YE, 0);
  led_set(LED_L_RD, 1);    
  led_set(LED_R_RD, 1);
  while (!bgx1_init());
  led_set(LED_L_YE, 1);   
  led_set(LED_R_YE, 1);
  led_set(LED_L_RD, 0);   
  led_set(LED_R_RD, 0);

  
  
  motpwm_init();
  motpid_init();
  
  //bgx1_reset();
  //bgx1_termClear();
  // Hauptschleife:
  while(1) {
    sei();
    delay(20);
    
    if (bgx1_getStatus()==0xff) {
      bgx1_reset();
      
      bgx1_termGoto(2, 2);
      bgx1_termPrint("AN0:");

      bgx1_termGoto(2, 3);
      bgx1_termPrint("AN1:");

      bgx1_termGoto(2, 4);
      bgx1_termPrint("T:");
    
    
    }
    
    bgx1_DDR = 0x00;
    bgx1_PORT = 0x00;
    
    bgx1_syncInterface();
    bgx1_syncPort();
    uint16_t a0 = bgx1_getAnalog(0x40);
    uint16_t a1 = bgx1_getAnalog(0x41);
    uint16_t temp = bgx1_getAnalog(0xc8);
    char text[32];
    
    bgx1_setIllumination(a0);
    
    bgx1_termGoto(7, 2);
    sprintf(text, "%4i", (int)a0);
    bgx1_termPrint(text);

    bgx1_termGoto(7, 3);
    sprintf(text, "%4i", (int)a1);
    bgx1_termPrint(text);

    bgx1_termGoto(7, 4);
    sprintf(text, "%4i", (int)temp);
    bgx1_termPrint(text);

    bgx1_Leds = bgx1_Keys;
    
  }
  return 0;
}
