#include <nibobee/iodefs.h>
#include <nibobee/motpwm.h>
#include <nibobee/motpid.h>
#include <nibobee/analog.h>
#include <nibobee/led.h>
#include <nibobee/delay.h>
#include <nibobee/clock.h>
#include <nibobee/odometry.h>
#include <nibobee/sens.h>


#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

//                      (     ((v)<(l))? (l) :    (   ((v)>(h))? (h) : (v)   )        )
#define INTERVAL(l,v,h) (     ((v)<(l))? (l) :    (   ((v)>(h))? (h) : (v)   )        )

uint8_t led;
uint16_t counter;

static void delay_local(uint16_t time) {
  while (time>10) {
    _delay_ms(10);    
    while (sens_getLeft() || sens_getRight()) {
      int8_t l = sens_getLeft();
      int8_t r = sens_getRight();
      led_set (0, l);
      led_set (1, l);
      led_set (2, r);
      led_set (3, r);
      delay(60);
      led_set (0, 0);
      led_set (1, 0);
      led_set (2, 0);
      led_set (3, 0);
      delay(40);      
    }  
    time-=10;
  }
  while (time) {
    _delay_ms(1);
    time--;
  }  
}

static void show_led(uint8_t led) {
  led_set (0, led==0);
  led_set (1, led==1);
  led_set (2, led==2);
  led_set (3, led==3);
}


int main_leds() {
  activate_output_group(IO_LEDS);  // LED bits als Output
  sens_init();
  analog_init();
  odometry_init();


  while (1) {
    
    delay_local(200);
    
    switch (counter++) {
      case 0: show_led(0); break;
      case 1: show_led(1); break;
      case 2: show_led(2); break;
      case 3: show_led(3); break;
      case 4: show_led(0xff); break;
      case 5: show_led(3); break;
      case 6: show_led(2); break;
      case 7: show_led(1); break;
      case 8: show_led(0); break;
      case 9: show_led(0xff); counter=0; break;
    }
        
  }

  
  
  return 0;
}
