#include <nibobee/iodefs.h>
#include <nibobee/motpwm.h>
#include <nibobee/motpid.h>
#include <nibobee/analog.h>
#include <nibobee/led.h>
#include <nibobee/delay.h>
#include <nibobee/clock.h>
#include <nibobee/odometry.h>
#include <nibobee/sens.h>


#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

int main_obst();
int main_leds();
int main_square();


int main() {
  activate_output_group(IO_LEDS);  // LED bits als Output
  sens_init();
  led_set(LED_L_RD, 1);
  led_set(LED_R_RD, 1);
  led_set(LED_L_YE, 1);
  led_set(LED_R_YE, 1);
  _delay_ms(200);
  int8_t l = sens_getLeft();
  int8_t r = sens_getRight();
  led_set(LED_L_RD, 0);
  led_set(LED_R_RD, 0);
  led_set(LED_L_YE, 0);
  led_set(LED_R_YE, 0);
  
  if (l==1) {
    main_obst();
  } else if (r==1) {
    main_square();
  } else {
    main_leds();
  }    

  return 0;  
}
