// NIBO 2 robot definitions


#define NSP_REGISTERS 32

enum {
  /* System */
  NSPREG_BOTID     =  0,
  NSPREG_VERSION   =  1,
  NSPREG_VSUPPLY   =  2,
  /* LEDs */
  NSPREG_LEDS      =  3,
  /* Sensors */  
  NSPREG_SENS      =  4,
  /* Motor */
  NSPREG_MOTMODE   =  6,
  NSPREG_MOTL      =  7,
  NSPREG_MOTR      =  8,
  NSPREG_MOTSPEED  =  9,
  /* Odometry */ 
  NSPREG_ODOL      = 13,
  NSPREG_ODOR      = 14,
  /* Line */
  NSPREG_LINEC     = 16,
  NSPREG_LINEL     = 17,
  NSPREG_LINER     = 18,
};

//#define NSP_REGISTER_TEXT "\n"

#define NSP_REGISTER_TEXT \
  "Registers:\n"\
  "=========\n"\
  " 0: BOT ID\n"\
  " 1: Version\n"\
  " 2: Supply Voltage [mV]\n"\
  " 3: LEDs\n"\
  " 4: Sensors\n"\
  " 6: Motor Mode \n"\
  " 7: Motor PWM L \n"\
  " 8: Motor PWM R \n"\
  " 9: Motor PID L \n"\
  "10: Motor PID R \n"\
  "13: Odometry L \n"\
  "14: Odometry R \n"\
  "16: Line C\n"\
  "17: Line L\n"\
  "18: Line R\n"\
  "\n"
