
#include <util/atomic.h>

#define SENSORIC_MODE_OFF 0
#define SENSORIC_MODE_LINE 1
#define SENSORIC_MODE_FLOOR 2


extern int8_t sensoric_line_pos;
extern int8_t sensoric_line_posf;
extern uint8_t sensoric_line_valid;


// floor basic
extern uint8_t sensoric_floor_l;
extern uint8_t sensoric_floor_c;
extern uint8_t sensoric_floor_r;

extern int8_t sensoric_floor_alert;

// floor angle
extern uint8_t sensoric_floor_cnt;
extern int16_t sensoric_floor_delta_t;
#define SENSORIC_ANGLE_HIST_SIZE 8
extern uint16_t sensoric_angle_hist[SENSORIC_ANGLE_HIST_SIZE];

// BKit-XS
extern int16_t sensoric_bkxs_l;
extern int16_t sensoric_bkxs_r;

extern int16_t sensoric_ori;

void sensoric_init(uint8_t mode);

void sensoric_reset_floor();

//static inline uint8_t sensoric_getLinePos() {ATOMIC_BLOCK(ATOMIC_RESTORESTATE) { return analog_samples[idx]; } return 0;}
static inline uint8_t sensoric_getLinePos() {return sensoric_line_pos;}
static inline uint8_t sensoric_getLinePosF() {return sensoric_line_posf;}

static inline int16_t sensoric_getBKitXS_L() {ATOMIC_BLOCK(ATOMIC_RESTORESTATE) { return sensoric_bkxs_l; } return 0;}
static inline int16_t sensoric_getBKitXS_R() {ATOMIC_BLOCK(ATOMIC_RESTORESTATE) { return sensoric_bkxs_r; } return 0;}
