#include <nibobee/iodefs.h>
#include <nibobee/motpwm.h>
#include <nibobee/motpid.h>
#include <nibobee/analog.h>
#include <nibobee/led.h>
#include <nibobee/delay.h>
#include <nibobee/clock.h>
#include <nibobee/odometry.h>
#include <nibobee/sens.h>


#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

//                      (     ((v)<(l))? (l) :    (   ((v)>(h))? (h) : (v)   )        )
#define INTERVAL(l,v,h) (     ((v)<(l))? (l) :    (   ((v)>(h))? (h) : (v)   )        )

uint8_t led;
uint16_t counter;


void go(uint16_t ticks) {
  uint16_t slow = (ticks>30)?(ticks-30):(0);
  
  led_set (1, 1);
  led_set (2, 1);
  odometry_reset();
  motpid_setSpeed (25, 25);
  while (odometry_getLeft(0)<slow) {
    ;
  }
  motpid_setSpeed (5, 5);
  while (odometry_getLeft(0)<ticks) {
    ;
  }
  led_set (1, 0);
  led_set (2, 0);
  motpid_stop(1);
}

void turnL(uint16_t ticks) {
  led_set (0, 1);
  odometry_reset();
  motpid_setSpeed (0, 10);
  while (odometry_getRight(0)<ticks) {
    ;
  }
  led_set (0, 0);
  motpid_stop(1);
}

void turnR(uint16_t ticks) {
  led_set (3, 1);
  odometry_reset();
  motpid_setSpeed (10, 0);
  while (odometry_getLeft(0)<ticks) {
    ;
  }  
  led_set (3, 0);
  motpid_stop(1);
}



int main_square() {
  activate_output_group(IO_LEDS);  // LED bits als Output
  sens_init();
  analog_init();
  odometry_init();
  motpid_init();

  _delay_ms(2000);

  while (1) {
    sei();
    _delay_ms(200);
    go(180);
    _delay_ms(200);
    turnL(31);
  }

  
  
  return 0;
}
