#include <nibobee/iodefs.h>
#include <nibobee/motpwm.h>
#include <nibobee/motpid.h>
#include <nibobee/analog.h>
#include <nibobee/led.h>
#include <nibobee/delay.h>
#include <nibobee/clock.h>
#include <nibobee/odometry.h>
#include <nibobee/sens.h>

#include <nibobee/rc5.h>

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

uint8_t toggle;

int main() {
  activate_output_group(IO_LEDS);  // LED bits als Output
  rc5_rx_enable();
  sens_init();

  led_set(LED_L_RD, 1);    
  led_set(LED_R_RD, 1);
  _delay_ms(500);
  led_set(LED_L_RD, 0);
  led_set(LED_R_RD, 0);
  _delay_ms(500);

  // Hauptschleife:
  while(1) {
    sei();
    /*
    led_set(0, (ir_state==1));
    led_set(1, (ir_state==2));
    led_set(2, (ir_state==3));
    led_set(3, (ir_state==4));
    */
    _delay_ms(1);
    uint16_t rc5 = rc5_rx_read();
    if (rc5==0x3145) {
      led_set(LED_L_YE, 1);    
      _delay_ms(100);      
      led_set(LED_L_YE, 0);
    }    
    if (rc5==0x3945) {
      led_set(LED_R_YE, 1);    
      _delay_ms(100);      
      led_set(LED_R_YE, 0);
    }
    
    if (sens_getLeft()) {
      while (sens_getLeft()) {
      }
      if (toggle) {
        rc5_tx_start(0x3149);
        toggle=0;
      } else {
        rc5_tx_start(0x3949);        
        toggle=1;
      }
    }
      
  }
  return 0;
}
