#include <nibobee/iodefs.h>
#include <nibobee/motpwm.h>
#include <nibobee/motpid.h>
#include <nibobee/analog.h>
#include <nibobee/led.h>
#include <nibobee/delay.h>
#include <nibobee/clock.h>
#include <nibobee/odometry.h>

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

void blinkled(uint8_t i) {
  PORTD &= (uint8_t)~0x03;
  if (i&0x02) {
    PORTD |= 0x01;
  } else {
    PORTD |= 0x02;
  }
}

void roundled(uint8_t i) {
  PORTC |= 0x0f;
  PORTA |= 0x0f;

  if (i>=16) {
    return;
  }
  if (i<8) {
    i=7-i;
  }
  
  switch (i&0x03) {
    case 0x00: PORTA &= (uint8_t)~0x01; break;
    case 0x01: PORTA &= (uint8_t)~0x02; break;
    case 0x02: PORTA &= (uint8_t)~0x04; break;
    case 0x03: PORTA &= (uint8_t)~0x08; break;
  }
  switch (i&0x0c) {
    case 0x00: PORTC &= (uint8_t)~0x04; break;
    case 0x04: PORTC &= (uint8_t)~0x01; break;
    case 0x08: PORTC &= (uint8_t)~0x02; break;
    case 0x0c: PORTC &= (uint8_t)~0x08; break;
  }
  
}

int main() {
  DDRD|=0x03;
  DDRA|=0x0f;
  DDRC|=0x0f;
  
  activate_output_group(IO_LEDS);  // LED bits als Output

  
  // Hauptschleife:
  while(1) {
    sei();
    for (uint8_t i=0; i<20; ++i) {
      blinkled(i);
      roundled(i);
      _delay_ms(100);
    }
  }
  return 0;
}
