/*
  Dieses Testprogramm läßt beim NIBObee die linke rote LED blinken.
*/


#include <nibobee/iodefs.h>          /* muss immer als erste Datei
                                        eingebunden werden */
#include <nibobee/delay.h>
#include <nibobee/led.h>
#include <nibobee/sens.h>
#include <nibobee/analog.h>
#include <nibobee/line.h>



void line_read_persistent();
uint16_t line_get(uint8_t idx);
void line_calibrate_white();
void line_calibrate_black();

void do_blink(uint8_t mask) {
  for (int i=0; i<5; ++i) {
    led_set(LED_L_RD, mask&0x01);
    led_set(LED_R_RD, mask&0x01);
    led_set(LED_L_YE, mask&0x02);
    led_set(LED_R_YE, mask&0x02);
    delay(200);
    led_set(LED_L_RD, 0);
    led_set(LED_R_RD, 0);
    led_set(LED_L_YE, 0);
    led_set(LED_R_YE, 0);
    delay(200);
  }
}


int main() {
  led_init();
  motpwm_init();
  sens_init();
  analog_init();
  activate_output_bit(IO_LINE_EN);

  line_readPersistent();

  while(1==1) {                      // Endlosschleife (1==1 ist immer wahr!)
    enable_interrupts();
    delay(10);
    int16_t speed_l=0;
    int16_t speed_r=0;

    if (sens_getLeft()==-1) {
      while (sens_getLeft()==-1) delay(1);
      line_calibrateWhite();
      do_blink(2);
    }
     
    if (sens_getRight()==-1) {
      while (sens_getRight()==-1) delay(1);
      line_calibrateBlack();
      do_blink(1);
    }

    set_output_groupbitval(IO_LEDS, L_YE, line_get(LINE_L)>0x010);
    set_output_groupbitval(IO_LEDS, L_RD, line_get(LINE_L)>0x380);
    set_output_groupbitval(IO_LEDS, R_YE, line_get(LINE_R)>0x010);
    set_output_groupbitval(IO_LEDS, R_RD, line_get(LINE_R)>0x380);

    if ((sens_getLeft()==1) && (sens_getRight()==1)) {
      while ((sens_getLeft()==1) && (sens_getRight()==1)) {
        delay(1);
      }
      line_writePersistent();
      do_blink(3);
    }

  }
  return 0;
}

