
#include <nibobee/iodefs.h>
#include <nibobee/usart.h>
#include <nibobee/motpwm.h>
#include <nibobee/analog.h>
#include <nibobee/odometry.h>

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

void print_hex (uint8_t val) {
  char c1=val/16;
  char c2=val%16;
  if (c1<10) c1+='0'; else c1+='a'-10;
  if (c2<10) c2+='0'; else c2+='a'-10;
  usart_putchar(c1);
  usart_putchar(c2);
}


int8_t decode_l (uint8_t val) {
  if (val==0x01) return -1;
  if (val==0x02) return 1;
  return 0;
}

int8_t decode_r (uint8_t val) {
  if (val==0x01) return 1;
  if (val==0x02) return -1;
  return 0;
}

int main() {
  activate_output_group(IO_LEDS);  // LED bits als Output
  usart_setbaudrate(9600);
  usart_enable();
  motpwm_init();
  odometry_init();
  motpwm_setLeft(1022);
  motpwm_setRight(1022);

  while(1) {
    sei();

    _delay_ms(1);

    if (usart_txempty()) {
      int16_t lval = odometry_getLeft(0);
      int16_t rval = odometry_getRight(0);
      print_hex(HIBYTE(lval));
      print_hex(LOBYTE(lval));
      usart_putchar(':');
      print_hex(HIBYTE(rval));
      print_hex(LOBYTE(rval));
      usart_putchar(10);
      usart_putchar(13);
    }
    
  }
  return 0; 
}
