#include <nibobee/iodefs.h>
#include <nibobee/motpwm.h>
#include <nibobee/motpid.h>
#include <nibobee/analog.h>
#include <nibobee/led.h>
#include <nibobee/delay.h>
#include <nibobee/clock.h>
#include <nibobee/odometry.h>

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>


int main() {
  activate_output_group(IO_LEDS);  // LED bits als Output
  motpwm_init();
  motpwm_setLeft(400);
  motpwm_setRight(400);
  motpid_init();
  odometry_init();

  uint16_t time = 0;
  
  // Hauptschleife:
  while(1) {
    sei();
    _delay_ms(100);
    
    if (clock_sec&0x01) {
        led_set(LED_L_YE, 1);    
        led_set(LED_R_YE, 0);
    } else {
        led_set(LED_L_YE, 0);
        led_set(LED_R_YE, 1);    
    }
    
    switch (time) {
      case 0:
        led_set(LED_L_RD, 1);
        led_set(LED_R_RD, 1);
	//motpwm_setLeft(1000);
	//motpwm_setRight(1000);
	motpid_setSpeed(20, 20);
	//motpid_setTarget(100, 100, 15);
	break;
	
      case 100:
        led_set(LED_L_RD, 0);
        led_set(LED_R_RD, 0);
	//motpwm_setLeft(-1000);
	//motpwm_setRight(-1000);
	motpid_setSpeed(-20, -20);
	//motpid_setTarget(0, 0, 15);
	break;
    }
    if (++time >= 200) {
      time=0;
    }
  }
  return 0;
}
