/*
  Dieses Testprogramm zeigt die Stände der Odometriezahler mit den LEDs an.
  Überschreitet der Zähler den Wert 10 leuchtet die gelbe LED, überschreitet
  der Zähler den Wert 20 leuchtet die rote LED.
  Durch Betätigung eines Fühlers werden die Zähler zurückgesetzt.
*/


#include <nibobee/iodefs.h>          /* muss immer als erste Datei
                                        eingebunden werden */
#include <nibobee/led.h>             /* Funktionen fuer die LEDs */
#include <nibobee/odometry.h>
#include <nibobee/sens.h>


int main() {
  led_init();                        // IO-Ports der LEDs als Ausgänge
                                     // konfigurieren
  odometry_init();
  sens_init();


  while(1==1) {                      // Endlosschleife (1==1 ist immer wahr!)
    enable_interrupts();
    if (sens_getLeft() || sens_getRight()) {
      odometry_reset();
    }
    
    led_set(LED_L_YE, odometry_getLeft(0)>10);
    led_set(LED_L_RD, odometry_getLeft(0)>20);
    led_set(LED_R_RD, odometry_getRight(0)>20);
    led_set(LED_R_YE, odometry_getRight(0)>10);
  }
  return 0;
}

