#include <niboburger/robomain.h>

uint8_t mode;

uint8_t prog=0;

void setup() {
  analog_init();
  led_init();
  odometry_init();
  motpwm_init();
  motpid_init();
}


void go(int32_t dist) {
  int32_t ticks = dist * TICKS_PER_METER / 1000;  
  motpid_setTargetRel (ticks, ticks, 40);
}

void turn(int16_t deg) {
  int32_t ticks;
  if (deg<0) {
    ticks = -deg;
    ticks = ticks * TICKS_PER_TURN_SINGLE / 360;
    motpid_setTargetRel (0, ticks, 20);
  } else if (deg>0) {
    ticks = deg;
    ticks = ticks * TICKS_PER_TURN_SINGLE / 360;
    motpid_setTargetRel (ticks, 0, 20);
  }
}


void loop() {
  analog_wait_update();
  char key = key_get_char ();
  if (key=='A') {
    motpid_setTargetRel (5*TICKS_PER_METER, 0, 40);
  }  
}
