#include <niboburger/robomain.h>

uint8_t mode;

uint8_t prog=0;

void setup() {
  analog_init();
  led_init();
  odometry_init();
  motpwm_init();
  motpid_init();
}


void go(int32_t dist) {
  int32_t ticks = dist * TICKS_PER_METER / 1000;  
  motpid_setTargetRel (ticks, ticks, 40);
}

void turn(int16_t deg) {
  int32_t ticks;
  if (deg<0) {
    ticks = -deg;
    ticks = ticks * TICKS_PER_TURN_SINGLE / 360;
    motpid_setTargetRel (0, ticks, 20);
  } else if (deg>0) {
    ticks = deg;
    ticks = ticks * TICKS_PER_TURN_SINGLE / 360;
    motpid_setTargetRel (ticks, 0, 20);
  }
}


void loop() {
  analog_wait_update();
  char key = key_get_char ();
  if (key=='A') {
    prog=1;
    go(2900);
    led_setall(0, 1, 1, 0);
  } else if (key=='B') {
    turn(-90);    
    led_setall(1, 0, 0, 0);
  } else if (key=='C') {
    motpwm_setLeft(800);
    motpwm_setRight(800);
    odometry_reset();
    mode=1;
    //turn(+90);
    led_setall(0, 0, 0, 1);
  }

  
  
  
  
  
  
  
  
  if (mode) {
    if (odometry_getLeft(0)>TICKS_PER_METER) {
      mode=0;
    motpwm_stop();
    led_setall(0, 0, 0, 0);
      
    }
  } else if (motpid_getTargetDist()<6) {
    motpid_release();
    motpwm_stop();
    led_setall(0, 0, 0, 0);
    delay(250);

    if (prog==1) {
      prog=2;
      turn(90);
      led_setall(0, 0, 1, 1);
    } else if (prog==2) {
      prog=3;
      go(800);
      led_setall(1, 1, 1, 1);
    }

    
  }
  
}
