#include "cdll.h"

// based on TNKernel


void cdll_reset(cdll_t *head) {
  head->next = head;
  head->prev = head;
}


void cdll_push_front(cdll_t * head, cdll_t * entry) {
  // assert (head!=0)
  // assert (entry!=0)
  entry->next = head->next;
  entry->prev = head;
  head->next = entry;
  entry->next->prev = entry;
}

void cdll_push_back(cdll_t * head, cdll_t * entry) {
  // assert (head!=0)
  // assert (entry!=0)
  entry->prev = head->prev;
  entry->next = head;
  head->prev = entry;
  entry->prev->next = entry;
}

cdll_t * cdll_pop_front(cdll_t * head) {
  // assert (head!=0)
  cdll_t * entry;
  if (head->next==head) {
    return (cdll_t *) 0;
  } 
  entry = head->next;
  entry->next->prev = head;
  head->next = entry->next;
  return entry;
}

cdll_t * cdll_pop_back(cdll_t * head) {
  // assert (head!=0)
  cdll_t * entry;
  if (head->prev==head) {
    return (cdll_t *) 0;
  } 
  entry = head->prev;
  entry->prev->next = head;
  head->prev = entry->prev;
  return entry;
}

void cdll_remove(cdll_t * entry) {
  entry->prev->next = entry->next;
  entry->next->prev = entry->prev;
}

bool cdll_contains(cdll_t * head, cdll_t * entry) {
  // assert (head!=0)
  cdll_t * current = head->next;
  while (current != head) {
    if (current==entry) {
      return true;
    }
    current = current->next;
  }
  return false;
}


void cdll_move_front(cdll_t * head, cdll_t * entry) {
  // remove
  entry->prev->next = entry->next;
  entry->next->prev = entry->prev;
  // push_front  
  entry->next = head->next;
  entry->prev = head;
  head->next = entry;
  entry->next->prev = entry;
}


void cdll_move_back(cdll_t * head, cdll_t * entry) {
  // remove
  entry->prev->next = entry->next;
  entry->next->prev = entry->prev;
  // push back
  entry->prev = head->prev;
  entry->next = head;
  head->prev = entry;
  entry->prev->next = entry;  
}
