/*! \mainpage Übersicht
 *
 * \section intro_sec Einleitung
 * Die NIBO Library vereinfacht den Zugriff auf die Hardware der <a href="http://nibo.nicai-systems.com" target="_blank">NIBO Roboter</a> sowohl unter der Programmiersprache C wie auch unter der Programmiersprache C++.
 * Der Bibliothek ist sowohl für den Nibo Version 1 wie auch für den NIBO 2 geeignet. Der Quellcode auf der <a href="http://sourceforge.net/projects/nibo/" target="_blank">Sourceforge Seite</a> enthält auch die Firmware der Coprozessoren.
 * Weitere Informationen befinden sich im <a href="http://www.nibo-roboter.de/wiki" target="_blank">Wiki</a>.
 *
 * Die Bibliothek besteht aus drei Teilen:
 * \section hl_sec High-Level Module
 * - bot.h
 * - copro.h (NIBO2)
 * - floor.h
 * - gfx.h
 * - leds.h
 * - text.h
 * - \[irco.h\] (Nibo Ver. 1)
 * - \[motco.h\] (Nibo Ver. 1)
 * \section ll_sec Low-Level Module
 * - adc.h
 * - delay.h
 * - display.h
 * - i2cmaster.h
 * - pwm.h
 * - sound.h (NIBO2)
 * - spi.h (NIBO2)
 * - uart0.h
 * - uart1.h (NIBO2)
 * - utils.h - Praktische Hilfs-Funktionen (min/max/constrain, etc...)
 * \section ext_sec Erweiterungen
 * - nds3.h (NIBO2)
 * - xbee.h (NIBO2)
 *
 */

