/*! \mainpage Übersicht
 *
 * \section intro_sec Einleitung
 *
 * Dies ist die Dokumentation der C Bibliothek f&uuml;r den <a href="http://nibobee.nicai-systems.de" target="_blank">NIBObee Roboter</a>.
 * Weitere Informationen befinden sich im <a href="http://www.nibo-roboter.de/wiki/NIBObee" target="_blank">Wiki</a> und auf der
 * <a href="http://sourceforge.net/projects/nibo/" target="_blank">SourceForge Projektseite der NiboRoboLib</a>
 *
 * Die enthaltenen .lib Dateien benötigen WinAVR-20100110, siehe <a href="http://www.nibo-roboter.de/wiki/NIBObee/FAQ" target="_blank">FAQ</a>!
 *
 * Die Bibliothek besteht aus folgenden Teilen:
 * - <b>libnibobee_base.a</b> (verwendet ADC, Timer1, INT0 und INT1)
 *  - analog.h - analoge Eing&auml;nge
 *  - base.h - Basisfunktionen / Initialisierung
 *  - clock.h - Funktionen zur genauen Zeiterfassung/Verz&ouml;gerung (optional)
 *  - iodefs.h - digitale Ein-/Ausg&auml;nge allgemein
 *  - iodefs_nibobee.h - digitale Ein-/Ausgänge Zuordnung der Port-Pins
 *  - led.h - Ein-/Ausschalten der LEDs
 *  - motpwm.h - Ansteuerung der Motoren
 *  - odometry.h - Auswertung der Drehimpulse der Räder
 *  - feeler.h - Fühler
 *  - utils.h - Praktische Hilfs-Funktionen (min/max/constrain, etc...)
 *
 * - <b>libnibobee_bgx1.a</b> (verwendet TWI)
 *  - bgx1.h - BGX1 Grafikdisplay Erweiterung (optional)
 *  - i2cmaster.h - I2C Bus Funktionen
 *
 * - <b>libnibobee_line.a</b>
 *  - line.h - kalibrierte Liniensensoren
 *
 * - <b>libnibobee_pid.a</b> (verwendet Timer1)
 *  - motpid.h - PID-Motorregelung
 *
 * - <b>libnibobee_usart.a</b> (verwendet USART0)
 *  - usart.h - serielle Schnittstelle (X5)
 *
 * - <b>libnibobee_utils.a</b>
 *  - delay.h - Funktionen zur Verzögerung
 *
 *
 */


